searchNodes=[{"doc":"Some common utility functions.","ref":"Bundlex.html","title":"Bundlex","type":"module"},{"doc":"Returns path where compiled native is stored.","ref":"Bundlex.html#build_path/3","title":"Bundlex.build_path/3","type":"function"},{"doc":"Returns family of the platform obtained with platform/0.","ref":"Bundlex.html#family/0","title":"Bundlex.family/0","type":"function"},{"doc":"Returns current platform name.","ref":"Bundlex.html#platform/0","title":"Bundlex.platform/0","type":"function"},{"doc":"","ref":"Bundlex.html#t:platform_t/0","title":"Bundlex.platform_t/0","type":"type"},{"doc":"Utilities to ease interaction with Bundlex-based CNodes, so they can be treated more like Elixir processes / GenServers.","ref":"Bundlex.CNode.html","title":"Bundlex.CNode","type":"module"},{"doc":"Makes a synchronous call to CNode and waits for its reply.The CNode is supposed to send back a {cnode, response} tuple where cnode is the node name of CNode. If the response doesn't come in within timeout, error is raised.Messages are exchanged directly (without interacting with CNode's associated server).","ref":"Bundlex.CNode.html#call/3","title":"Bundlex.CNode.call/3","type":"function"},{"doc":"Starts monitoring CNode from the calling process.","ref":"Bundlex.CNode.html#monitor/1","title":"Bundlex.CNode.monitor/1","type":"function"},{"doc":"Sends a message to cnode.The message is exchanged directly (without interacting with CNode's associated server).","ref":"Bundlex.CNode.html#send/2","title":"Bundlex.CNode.send/2","type":"function"},{"doc":"Spawns and connects to CNode cnode_name from application of calling module.See Bundlex.CNode.start/2 for more details.","ref":"Bundlex.CNode.html#start/1","title":"Bundlex.CNode.start/1","type":"macro"},{"doc":"Works the same way as start_link/2, but does not link to CNode's associated server.","ref":"Bundlex.CNode.html#start/2","title":"Bundlex.CNode.start/2","type":"function"},{"doc":"Spawns and connects to CNode cnode_name from application of calling module.See Bundlex.CNode.start_link/2 for more details.","ref":"Bundlex.CNode.html#start_link/1","title":"Bundlex.CNode.start_link/1","type":"macro"},{"doc":"Spawns and connects to CNode cnode_name from application app.The CNode is passed the following command line arguments:host name,alive name,node name,cookie,creation number.After CNode startup, these parameters should be passed to ei_connect_xinit function, and CNode should be published and await connection. Once the CNode is published, it should print a line starting with ready to the standard output and flush the standard output to avoid the line being buffered.Under the hood, this function starts an associated server, which is responsible for monitoring the CNode and monitoring calling process to be able to do proper cleanup upon a crash. On startup, the server does the following:Makes current node distributed if it is not done yet (see Node.start/3).Assigns CNode a unique name.Starts CNode OS process using Port.open/2.Waits (at most 5 seconds) until a line ready is printed out (this line is captured and not forwarded to the stdout).Connects to the CNode.","ref":"Bundlex.CNode.html#start_link/2","title":"Bundlex.CNode.start_link/2","type":"function"},{"doc":"Disconnects from CNode.It is the responsibility of the CNode to exit upon connection loss.","ref":"Bundlex.CNode.html#stop/1","title":"Bundlex.CNode.stop/1","type":"function"},{"doc":"","ref":"Bundlex.CNode.html#t:on_start_t/0","title":"Bundlex.CNode.on_start_t/0","type":"type"},{"doc":"Reference to the CNode.Consists of pid of CNode's associated server and CNode name.","ref":"Bundlex.CNode.html#t:t/0","title":"Bundlex.CNode.t/0","type":"type"},{"doc":"Some utilities to ease loading of Bundlex-based NIFs.","ref":"Bundlex.Loader.html","title":"Bundlex.Loader","type":"module"},{"doc":"Binds the module to the specified NIF.Accepts keyword list, that may contain two arguments::nif - required, name of the NIF to be bound (the same as specified in bundlex.exs):app - application defining the NIF, defaults to the current applicationAfter use'ing this module you can utilize defnif/1 and defnifp/1 macros to create bindings to particular native functions.Exampledefmodule My.Native.Module do use Bundlex.Loader, nif: :my_nif defnif native_function(arg1, arg2, arg3) def normal_function(arg1, arg2) do # ... end defnifp private_native_function(arg1, arg2) end","ref":"Bundlex.Loader.html#__using__/1","title":"Bundlex.Loader.__using__/1","type":"macro"},{"doc":"Generates function bound to the native implementation. This module has to be used for this macro to work.Function name should correspond to the native one.See __using__/1 for examples.","ref":"Bundlex.Loader.html#defnif/1","title":"Bundlex.Loader.defnif/1","type":"macro"},{"doc":"Works the same way as defnif/1, but generates private function. This module has to be used for this macro to work.See __using__/1 for examples.","ref":"Bundlex.Loader.html#defnifp/1","title":"Bundlex.Loader.defnifp/1","type":"macro"},{"doc":"Binds calling module to NIF nif_name from application app.Second argument has to be an atom, the same as name of the NIF in the bundlex project.Invoked internally by __using__/1 macro, which is the preferred way of loading NIFs.","ref":"Bundlex.Loader.html#load_nif!/2","title":"Bundlex.Loader.load_nif!/2","type":"macro"},{"doc":"Module responsible for parsing and processing natives' configurations.","ref":"Bundlex.Native.html","title":"Bundlex.Native","type":"module"},{"doc":"Parses natives and generates compiler commands.","ref":"Bundlex.Native.html#resolve_natives/2","title":"Bundlex.Native.resolve_natives/2","type":"function"},{"doc":"","ref":"Bundlex.Native.html#t:interface_t/0","title":"Bundlex.Native.interface_t/0","type":"type"},{"doc":"","ref":"Bundlex.Native.html#t:t/0","title":"Bundlex.Native.t/0","type":"type"},{"doc":"Utilities to ease interaction with Ports.","ref":"Bundlex.Port.html","title":"Bundlex.Port","type":"module"},{"doc":"Spawns Port native_name from application of calling module. Returned result is compatible with standard Port API.","ref":"Bundlex.Port.html#open/2","title":"Bundlex.Port.open/2","type":"macro"},{"doc":"","ref":"Bundlex.Port.html#open/3","title":"Bundlex.Port.open/3","type":"function"},{"doc":"Behaviour that should be implemented by each project using Bundlex in the bundlex.exs file.","ref":"Bundlex.Project.html","title":"Bundlex.Project","type":"behaviour"},{"doc":"Returns the project struct of given application.If the module has not been loaded yet, it is loaded from project_dir/bundlex.exs file.","ref":"Bundlex.Project.html#get/1","title":"Bundlex.Project.get/1","type":"function"},{"doc":"","ref":"Bundlex.Project.html#native_config_keys/0","title":"Bundlex.Project.native_config_keys/0","type":"function"},{"doc":"Callback returning project configuration.","ref":"Bundlex.Project.html#c:project/0","title":"Bundlex.Project.project/0","type":"callback"},{"doc":"Determines if module is a bundlex project module.","ref":"Bundlex.Project.html#project_module?/1","title":"Bundlex.Project.project_module?/1","type":"function"},{"doc":"Type describing input project configuration.It's a keyword list, where natives and libs can be specified. :nifs, :cnodes and :ports keys are deprecated. Instead, use :natives with proper :interfaces. Libs are native packages that are compiled as static libraries and linked to natives that have them specified in deps field of their configuration.","ref":"Bundlex.Project.html#t:config_t/0","title":"Bundlex.Project.config_t/0","type":"type"},{"doc":"Type describing configuration of a native.It's a keyword list containing the following keys:sources - C files to be compiled (at least one must be provided),includes - Paths to look for header files (empty list by default).lib_dirs - Paths to look for libraries (empty list by default).libs - Names of libraries to link (empty list by default).pkg_configs - Names of libraries for which the appropriate flags will be obtained using pkg-config (empty list by default).deps - Dependencies in the form of {app, lib_name}, where app is the application name of the dependency, and lib_name is the name of lib specified in bundlex project of this dependency. See Dependencies section in readme for details.src_base - Native files should reside in project_root/c_src/&lt;src_base&gt; (application name by default).compiler_flags - Custom flags for compiler.linker_flags - Custom flags for linker.language - Language of native. :c or :cpp may be chosen (:c by default)interface - Interface of native. It can be single atom e.g. :nif or list of atoms.preprocessors - Modules implementing Bundlex.Project.Preprocessor behaviour","ref":"Bundlex.Project.html#t:native_config_t/0","title":"Bundlex.Project.native_config_t/0","type":"type"},{"doc":"","ref":"Bundlex.Project.html#t:native_name_t/0","title":"Bundlex.Project.native_name_t/0","type":"type"},{"doc":"Struct representing bundlex project.Contains the following fileds::config - project configuration:src_path - path to the native sources:module - bundlex project module:app - application that exports project","ref":"Bundlex.Project.html#t:t/0","title":"Bundlex.Project.t/0","type":"type"},{"doc":"Behaviour for preprocessing Bundlex projects.Precompiling may involve either generating additional resources or altering the project itself. Currently, preprocessing native configuration (preprocess_native_config/3) and parsed natives (preprocess_native/1) is supported.","ref":"Bundlex.Project.Preprocessor.html","title":"Bundlex.Project.Preprocessor","type":"behaviour"},{"doc":"","ref":"Bundlex.Project.Preprocessor.html#c:preprocess_native/1","title":"Bundlex.Project.Preprocessor.preprocess_native/1","type":"callback"},{"doc":"","ref":"Bundlex.Project.Preprocessor.html#c:preprocess_native_config/3","title":"Bundlex.Project.Preprocessor.preprocess_native_config/3","type":"callback"},{"doc":"","ref":"Bundlex.Project.Preprocessor.html#t:t/0","title":"Bundlex.Project.Preprocessor.t/0","type":"type"},{"doc":"Builds natives specified in bundlex.exs fileAccepts the following command line arguments:--store-scripts - if set, shell scripts are stored in the project root folder for further analysis.Add :bundlex to compilers in your Mix project to have this task executed each time the project is compiled.","ref":"Mix.Tasks.Compile.Bundlex.html","title":"Mix.Tasks.Compile.Bundlex","type":"task"},{"doc":"Module containing helper functions that ease determining path to locally- installed Erlang.","ref":"Bundlex.Helper.ErlangHelper.html","title":"Bundlex.Helper.ErlangHelper","type":"module"},{"doc":"Tries to determine paths to includes directory of locally installed Erlang.","ref":"Bundlex.Helper.ErlangHelper.html#get_includes/1","title":"Bundlex.Helper.ErlangHelper.get_includes/1","type":"function"},{"doc":"Tries to determine paths to libs directory of locally installed Erlang.","ref":"Bundlex.Helper.ErlangHelper.html#get_lib_dirs/1","title":"Bundlex.Helper.ErlangHelper.get_lib_dirs/1","type":"function"},{"doc":"Module simplifying interaction with Git.","ref":"Bundlex.Helper.GitHelper.html","title":"Bundlex.Helper.GitHelper","type":"module"},{"doc":"Determines whether the Git Large File Storage is activated on the current machine.","ref":"Bundlex.Helper.GitHelper.html#lfs_present?/0","title":"Bundlex.Helper.GitHelper.lfs_present?/0","type":"function"},{"doc":"Module containing helper functions that ease retreiving certain values from Mix configuration files.","ref":"Bundlex.Helper.MixHelper.html","title":"Bundlex.Helper.MixHelper","type":"module"},{"doc":"Helper function for retreiving app name from mix.exs and failing if it was not found.","ref":"Bundlex.Helper.MixHelper.html#get_app!/0","title":"Bundlex.Helper.MixHelper.get_app!/0","type":"function"},{"doc":"Returns app for the given module. In case of failure fallbacks to get_app!/0.","ref":"Bundlex.Helper.MixHelper.html#get_app!/1","title":"Bundlex.Helper.MixHelper.get_app!/1","type":"function"},{"doc":"Returns path to the priv dir for given application.","ref":"Bundlex.Helper.MixHelper.html#get_priv_dir/1","title":"Bundlex.Helper.MixHelper.get_priv_dir/1","type":"function"},{"doc":"Returns root directory of the currently compiled project.","ref":"Bundlex.Helper.MixHelper.html#get_project_dir/0","title":"Bundlex.Helper.MixHelper.get_project_dir/0","type":"function"},{"doc":"Returns root directory of the project of given application.","ref":"Bundlex.Helper.MixHelper.html#get_project_dir/1","title":"Bundlex.Helper.MixHelper.get_project_dir/1","type":"function"},{"doc":"Module containing helper functions that ease traversing directories.","ref":"Bundlex.Helper.PathHelper.html","title":"Bundlex.Helper.PathHelper","type":"module"},{"doc":"Fixes slashes in the given path to match convention used on current operating system.Internally all elixir functions use slash as a path separator, even if running on windows, and it's not a bug but a feature (lol).See https://github.com/elixir-lang/elixir/issues/1236","ref":"Bundlex.Helper.PathHelper.html#fix_slashes/1","title":"Bundlex.Helper.PathHelper.fix_slashes/1","type":"function"},{"doc":"Tries to find a path that matches given pattern that has the biggest version number if it is expected to be a suffix.","ref":"Bundlex.Helper.PathHelper.html#latest_wildcard/1","title":"Bundlex.Helper.PathHelper.latest_wildcard/1","type":"function"},{"doc":"Bundlex Bundlex is a multi-platform tool for compiling C code along with elixir projects, for use in NIFs, CNodes and Ports. The tool provides also convenient way of accessing compiled code in elixir modules.This tool is a part of Membrane Framework","ref":"readme.html","title":"Bundlex","type":"extras"},{"doc":"To install, you need to configure Mix project as follows:defmodule MyApp.Mixfile do use Mix.Project def project do [ app: :my_app, compilers: [:bundlex] ++ Mix.compilers, # add bundlex to compilers deps: deps(), # ... ] end defp deps() do [ {:bundlex, &quot;~&gt; 0.4.0&quot;} # add bundlex to deps ] end endand create bundlex.exs file in the project root folder, containing Bundlex project module:defmodule Membrane.Element.Mad.BundlexProject do use Bundlex.Project def project() do [] end endNow your project does not contain any C sources, but should compile successfully, and some Bundlex messages should be printed while compilation proceeds.","ref":"readme.html#instalation","title":"Bundlex - Instalation","type":"extras"},{"doc":"Adding natives to projectAdding natives can be done in project/0 function of Bundlex project module in the following way:defmodule MyApp.BundlexProject do use Bundlex.Project def project() do [ natives: natives(Bundlex.platform), libs: libs() ] end defp natives(:linux) do [ my_native: [ sources: [&quot;something.c&quot;, &quot;linux_specific.c&quot;], interface: :nif ], my_other_native: [ sources: [&quot;something_other.c&quot;, &quot;linux_specific.c&quot;], interface: :cnode ], my_other_native: [ sources: [&quot;something_more_other.c&quot;, &quot;linux_specific.c&quot;], interface: :port ] ] end defp natives(_platform) do [ my_native: [ sources: [&quot;something.c&quot;, &quot;multiplatform.c&quot;], interface: :nif ], my_other_native: [ sources: [&quot;something_other.c&quot;, &quot;multiplatform.c&quot;], interface: :cnode ], my_other_native: [ sources: [&quot;something_more_other.c&quot;, &quot;multiplatform.c&quot;], interface: :port ] ] end defp libs() do [ my_lib: [ sources: [&quot;something.c&quot;], interface: :nif ], my_lib: [ sources: [&quot;something_other.c&quot;], interface: :cnode ] ] end endAs we can see, we can specify two types of resources:natives - code implemented in C that will be used within Elixir codelibs - can be used by other resources as dependencies (see deps option below)The sources should reside in project_root/c_src/my_app directory (this can be changed with src_base option, see below).Configuration of each native may contain following options:sources - C files to be compiled (at least one must be provided),includes - Paths to look for header files (empty list by default).lib_dirs - Absolute paths to look for libraries (empty list by default).libs - Names of libraries to link (empty list by default).pkg_configs - Names of libraries for which the appropriate flags will be obtained using pkg-config (empty list by default).deps - Dependencies in the form of {app, lib_name}, where app is the application name of the dependency, and lib_name is the name of lib specified in Bundlex project of this dependency. Empty list by default. See Dependencies section below for details.src_base - Native files should reside in project_root/c_src/&lt;src_base&gt; (application name by default).compiler_flags - Custom flags for compiler.linker_flags - Custom flags for linker.language - Language of native. :c or :cpp may be chosen (:c by default)interface - Interface used to integrate with Elixir code. The following interfaces are available::nif - dynamically linked to the Erlang VM (see Erlang docs):cnode - executed as separate OS processes, accessed through sockets (see Erlang docs):port - executed as separate OS processes (see Elixir Port docs) Specifying no interface is valid only for libs.preprocessors - Modules that will preprocess the native, see Bundlex.Project.Preprocessor.DependenciesEach native can have dependencies - libs that are statically linked to it and can be included in its native code like #include lib_name/some_header.h. The following rules apply:To add dependencies from a separate project, it must be available via Mix. Only libs can be added as dependencies.Each dependency of a native must specify the same or no interface. If there exist multiple versions of dependency with different interfaces, the proper version is selected automatically.A lib that specifies no interface can depend on libs with no interfaces only.Compilation optionsThe following command-line arguments can be passed:--store-scripts - if set, shell scripts are stored in the project root folder for further analysis.Loading NIFs in modulesNIFs compiled with Bundlex can be loaded the same way as any other NIFs (see :erlang.load_nif/2), but Bundlex provides Bundlex.Loader module to save you some boilerplate:defmodule MyApp.SomeNativeStuff do use Bundlex.Loader, nif: :my_nif def normal_function(a, b, c, d) do private_native_function(a+b, c+d) end defnif native_function(a, b) defnifp private_native_function(x, y) endNote that unlike when using :erlang.load_nif/2, here defs and defps can be used to create usual functions, native ones are declared with defnif and defnifp. This is achieved by creating a new module under the hood, and that is why the module passed to C macro ERL_NIF_INIT has to be succeeded by .Nif, i.e.ERL_NIF_INIT(MyApp.SomeNativeStuff.Nif, funs, load, NULL, upgrade, unload)Despite this, any native erlang macros and functions shall be used as usual, as described at http://erlang.org/doc/man/erl_nif.htmlInteracting with CNodesAs in the case of NIFs, CNodes compiled with Bundlex can be used like any other CNodes (see built-in Node module), while some useful stuff for interacting with them is provided. Bundlex.CNode module contains utilities that make it easier to spawn and control CNodes, and allow them to treat them more like usual Elixir processes. Check out the documentation for more details.Interacting with PortsSimilarly to CNodes Bundlex provides Bundlex.Port module for a little easier interacting with Ports. Please refer to the module's documentation to see how to use it.","ref":"readme.html#usage","title":"Bundlex - Usage","type":"extras"},{"doc":"More advanced examples can be found in our test_projects or in our repositories where we use Bundlex e.g. in Unifex.","ref":"readme.html#more-examples","title":"Bundlex - More examples","type":"extras"},{"doc":"Copyright 2018, Software MansionLicensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":"Bundlex - Copyright and License","type":"extras"}]